#include "beremiz.h"
#ifndef __POUS_H
#define __POUS_H

#include "accessor.h"
#include "iec_std_lib.h"

__DECLARE_ENUMERATED_TYPE(LOGLEVEL,
  LOGLEVEL__CRITICAL,
  LOGLEVEL__WARNING,
  LOGLEVEL__INFO,
  LOGLEVEL__DEBUG
)
// FUNCTION_BLOCK LOGGER
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,MSG)
  __DECLARE_VAR(LOGLEVEL,LEVEL)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,TRIG0)

} LOGGER;

void LOGGER_init__(LOGGER *data__, BOOL retain);
// Code part
void LOGGER_body__(LOGGER *data__);
// FUNCTION_BLOCK PYTHON_EVAL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(DWORD,STATE)
  __DECLARE_VAR(STRING,BUFFER)
  __DECLARE_VAR(STRING,PREBUFFER)
  __DECLARE_VAR(BOOL,TRIGM1)
  __DECLARE_VAR(BOOL,TRIGGED)

} PYTHON_EVAL;

void PYTHON_EVAL_init__(PYTHON_EVAL *data__, BOOL retain);
// Code part
void PYTHON_EVAL_body__(PYTHON_EVAL *data__);
// FUNCTION_BLOCK PYTHON_POLL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(DWORD,STATE)
  __DECLARE_VAR(STRING,BUFFER)
  __DECLARE_VAR(STRING,PREBUFFER)
  __DECLARE_VAR(BOOL,TRIGM1)
  __DECLARE_VAR(BOOL,TRIGGED)

} PYTHON_POLL;

void PYTHON_POLL_init__(PYTHON_POLL *data__, BOOL retain);
// Code part
void PYTHON_POLL_body__(PYTHON_POLL *data__);
// FUNCTION_BLOCK PYTHON_GEAR
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(UINT,N)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  PYTHON_EVAL PY_EVAL;
  __DECLARE_VAR(UINT,COUNTER)
  __DECLARE_VAR(UINT,_TMP_ADD10_OUT)
  __DECLARE_VAR(BOOL,_TMP_EQ13_OUT)
  __DECLARE_VAR(UINT,_TMP_SEL15_OUT)
  __DECLARE_VAR(BOOL,_TMP_AND7_OUT)

} PYTHON_GEAR;

void PYTHON_GEAR_init__(PYTHON_GEAR *data__, BOOL retain);
// Code part
void PYTHON_GEAR_body__(PYTHON_GEAR *data__);
// PROGRAM ARDUINO_MEGA_LD
// Data part
typedef struct {
  // PROGRAM Interface - IN, OUT, IN_OUT variables

  // PROGRAM private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,I_BTN_S1_F)
  __DECLARE_VAR(BOOL,I_BTN_S1_B)
  __DECLARE_VAR(BOOL,I_BTN_S2_F)
  __DECLARE_VAR(BOOL,I_BTN_S2_B)
  __DECLARE_VAR(BOOL,I_SENSOR1)
  __DECLARE_VAR(BOOL,I_SENSOR2)
  __DECLARE_VAR(BOOL,I_SENSOR3)
  __DECLARE_VAR(BOOL,I_SENSOR4)
  __DECLARE_VAR(BOOL,I_SENSOR5)
  __DECLARE_VAR(BOOL,I_MILL)
  __DECLARE_VAR(BOOL,I_DRILL)
  __DECLARE_VAR(BOOL,Q_SLID1_F)
  __DECLARE_VAR(BOOL,Q_SLID1_B)
  __DECLARE_VAR(BOOL,Q_SLID2_F)
  __DECLARE_VAR(BOOL,Q_SLID2_B)
  __DECLARE_VAR(BOOL,Q_CONV1)
  __DECLARE_VAR(BOOL,Q_CONV2)
  __DECLARE_VAR(BOOL,Q_CONV3)
  __DECLARE_VAR(BOOL,Q_CONV4)
  __DECLARE_VAR(BOOL,Q_MILL)
  __DECLARE_VAR(BOOL,Q_DRILL)
  TOF TOF0;
  TON TON0;
  TOF TOF1;
  TON TON1;
  TOF TOF2;
  TON TON2;
  TOF TOF3;
  TON TON3;
  TOF TOF4;
  TON TON4;
  F_TRIG F_TRIG1;
  F_TRIG F_TRIG2;
  F_TRIG F_TRIG3;
  F_TRIG F_TRIG4;

} ARDUINO_MEGA_LD;

void ARDUINO_MEGA_LD_init__(ARDUINO_MEGA_LD *data__, BOOL retain);
// Code part
void ARDUINO_MEGA_LD_body__(ARDUINO_MEGA_LD *data__);
#endif //__POUS_H
