#include "beremiz.h"
#ifndef __POUS_H
#define __POUS_H

#include "accessor.h"
#include "iec_std_lib.h"

__DECLARE_ENUMERATED_TYPE(LOGLEVEL,
  LOGLEVEL__CRITICAL,
  LOGLEVEL__WARNING,
  LOGLEVEL__INFO,
  LOGLEVEL__DEBUG
)
// FUNCTION_BLOCK LOGGER
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,MSG)
  __DECLARE_VAR(LOGLEVEL,LEVEL)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,TRIG0)

} LOGGER;

void LOGGER_init__(LOGGER *data__, BOOL retain);
// Code part
void LOGGER_body__(LOGGER *data__);
// FUNCTION_BLOCK PYTHON_EVAL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(DWORD,STATE)
  __DECLARE_VAR(STRING,BUFFER)
  __DECLARE_VAR(STRING,PREBUFFER)
  __DECLARE_VAR(BOOL,TRIGM1)
  __DECLARE_VAR(BOOL,TRIGGED)

} PYTHON_EVAL;

void PYTHON_EVAL_init__(PYTHON_EVAL *data__, BOOL retain);
// Code part
void PYTHON_EVAL_body__(PYTHON_EVAL *data__);
// FUNCTION_BLOCK PYTHON_POLL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(DWORD,STATE)
  __DECLARE_VAR(STRING,BUFFER)
  __DECLARE_VAR(STRING,PREBUFFER)
  __DECLARE_VAR(BOOL,TRIGM1)
  __DECLARE_VAR(BOOL,TRIGGED)

} PYTHON_POLL;

void PYTHON_POLL_init__(PYTHON_POLL *data__, BOOL retain);
// Code part
void PYTHON_POLL_body__(PYTHON_POLL *data__);
// FUNCTION_BLOCK PYTHON_GEAR
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(UINT,N)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  PYTHON_EVAL PY_EVAL;
  __DECLARE_VAR(UINT,COUNTER)
  __DECLARE_VAR(UINT,ADD10_OUT)
  __DECLARE_VAR(BOOL,EQ13_OUT)
  __DECLARE_VAR(UINT,SEL15_OUT)
  __DECLARE_VAR(BOOL,AND7_OUT)

} PYTHON_GEAR;

void PYTHON_GEAR_init__(PYTHON_GEAR *data__, BOOL retain);
// Code part
void PYTHON_GEAR_body__(PYTHON_GEAR *data__);
// PROGRAM SFC_TEST1
// Data part
typedef struct {
  // PROGRAM Interface - IN, OUT, IN_OUT variables

  // PROGRAM private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,I_SENSOR1)
  __DECLARE_VAR(BOOL,I_SENSOR2)
  __DECLARE_VAR(BOOL,I_SENSOR3)
  __DECLARE_VAR(BOOL,I_SENSOR4)
  __DECLARE_VAR(BOOL,I_SENSOR5)
  __DECLARE_VAR(BOOL,I_BTN_LEFT1)
  __DECLARE_VAR(BOOL,I_BTN_LEFT2)
  __DECLARE_VAR(BOOL,I_BTN_RIGHT1)
  __DECLARE_VAR(BOOL,I_BTN_RIGHT2)
  __DECLARE_VAR(BOOL,Q_CONV1)
  __DECLARE_VAR(BOOL,Q_CONV2)
  __DECLARE_VAR(BOOL,Q_CONV3)
  __DECLARE_VAR(BOOL,Q_CONV4)
  __DECLARE_VAR(BOOL,Q_SLIDER1_FORWARD)
  __DECLARE_VAR(BOOL,Q_SLIDER1_BACKWARD)
  __DECLARE_VAR(BOOL,Q_SLIDER2_FORWARD)
  __DECLARE_VAR(BOOL,Q_SLIDER2_BACKWARD)
  __DECLARE_VAR(BOOL,Q_MILLING)
  __DECLARE_VAR(BOOL,Q_DRILLING)
  __DECLARE_VAR(BOOL,I_MILLING)
  __DECLARE_VAR(BOOL,I_DRILLING)
  TON TON0;
  TON TON1;
  TOF TOF0;
  TOF TOF1;
  __DECLARE_VAR(BOOL,START_TIMER_CONV3)
  __DECLARE_VAR(BOOL,START_TIMER_MILL)
  __DECLARE_VAR(BOOL,START_TIMER_DRILL)
  TON TON2;
  TOF TOF2;
  TON TON3;
  TOF TOF3;
  STEP __step_list[22];
  UINT __nb_steps;
  ACTION __action_list[14];
  UINT __nb_actions;
  __IEC_BOOL_t __transition_list[24];
  __IEC_BOOL_t __debug_transition_list[24];
  UINT __nb_transitions;
  TIME __lasttick_time;

} SFC_TEST1;

void SFC_TEST1_init__(SFC_TEST1 *data__, BOOL retain);
// Code part
void SFC_TEST1_body__(SFC_TEST1 *data__);
#endif //__POUS_H
